const model = require('./model');
const conn = require('./dbconnection');

/*
Transaktion koodi on Sequelizen ansiosta yksinkertaisen näköinen, koska metodit
palauttavat promiseja ja voimme käyttää async-await -rakennetta
*/

async function doTransaction() {

  const transaction = await conn.transaction();

  try {
    // transaktion vaihe 1
    await model.Grade.create({ studentcode: 'e1234', coursecode: 'HTX1234', grade: 5 }, transaction);

    // transaktion vaihe 2
    await model.Student.increment( ['studypoints'], { by: 5, where: { studentcode: 'e1234' }}, transaction);


    // commit
    await transaction.commit();

  } catch (err) {
    await transaction.rollback();
  }
};

doTransaction();
